#include <pic.h>
#include "lcd.h"
#include <stdlib.h>
#include <stdio.h>
#include	"delay.h"
#include	<math.h>

#define	D_PIN		RB1 
#define	D_TRIS		TRISB1
bit  D_Presence;
bit  D_ShortCircuit;
bit  D_Error;
bit  D_Data;


char TempH=0xFF;              //-- High Thermo setting
char TempL=0xFF;              //-- Low thermo setting
char TempS=0xFF;       
unsigned char	buf [16];
float			temperature;						// 
unsigned char	termo0;								//  DS18S20
unsigned char	termo1;
unsigned char	th;
unsigned char	tl;
unsigned char	reserv1;
unsigned char	reserv0;
unsigned char	count_remain;
unsigned char	count_perc;
unsigned char	crc;
unsigned char	buf [16];


#define D_RiseSpace 5        // Rise Time + Minimum Space (3uS+1uS absolute min)

char number[] = "                ";
char sec[] = "                ";


unsigned int secs,mins;


//****************************************************************************
//D_Reset  -- Resets the 1-wire bus and checks for presence & short cct
//****************************************************************************
void D_Reset(void)
{
 char count=47;
 //-- Reset the status bits
 D_Error=0;

 //-- Ensure Correct port pin settings
 D_TRIS=1;
 D_PIN=0;

 //-- Start the reset Pulse
 D_TRIS=0;          //-- Pull Line Low to start reset pulse
 for(;count>0;count--)
 {
  DelayUs(10);      //-- 480uS Delay
 }
 D_TRIS=1;          //-- Release the line
 DelayUs(50);       //-- Delay to about centre of presence pulse
 DelayUs(10);
 D_Presence=D_PIN;  //-- Get Presence status 1=None 0=something there
 for(count=41;count>0;count--) //-- (480-60)uS delay till end
 {
  DelayUs(10);
 }
 D_ShortCircuit=D_PIN;  //-- Check for short circuit on bus pin.

 if(D_ShortCircuit==0)  //-- If short circuit then indicate an error
 {
  D_Error=1;
 }
 if(D_Presence==1)      //-- If no device detected indicate an error
 {
  D_Error=1;
 }
 DelayUs(D_RiseSpace);    //-- Rise time + Min Space

}
//******************END OF D_Reset


//****************************************************************************
// D_Write
//****************************************************************************
void D_Write(Data)
{
 char count=8;
 for(;count>0;count--)
 {
  D_Data= Data & 0x01;    //-- Get LSB

  //-- Write the bit to the port
  D_PIN=0;
  D_TRIS=0;               //-- Lower the port
  DelayUs(5);             //-- Time slot start time
  D_TRIS=D_Data;          //-- Output the data to the port
  DelayUs(50);            //-- Finish Timeslot
  DelayUs(5);

  D_TRIS=1;               //-- Ensure Release of Port Pin

  //-- Delay Between Bits
  DelayUs(D_RiseSpace);             //-- Recovery time between Bits

  //-- Prep Next Bit
  Data=Data>>1;           //-- Shift next bit into place
 }
 DelayUs(D_RiseSpace);    //-- Rise time + Min Space
}
//******************END OF D_Write

//****************************************************************************
// D_Read
//****************************************************************************
char D_Read(void)
{
 char count=8,data=0;
 for(;count>0;count--)
 {
  //-- Write the bit to the port
  D_PIN=0;
  D_TRIS=0;               //-- Lower the port
  DelayUs(5);             //-- Time slot start time
  D_TRIS=1;               //-- Release port for reading
  DelayUs(5);             //-- Get close to center of timeslot
  D_Data=D_PIN;           //-- Read the data bit in
  DelayUs(50);            //-- Finish the timeslot

  //-- Put data into the byte
  data = data >> 1;        //-- Shift previous bits across
  if(D_Data==1)            //-- If data was high then add High bit to data
  {
   data +=0x80;
  }
  //-- Delay Between Bits
  DelayUs(D_RiseSpace);             //-- Recovery time between Bits
 }
 DelayUs(D_RiseSpace);    //-- Rise time + Min Space
 return(data);
}
//******************END OF D_Read

//************************************************************************
//                          ReadCurrent
//
//      thermo 
//************************************************************************
void ReadCurrent(void)
{
 D_Reset();          //-- Reset the Bus
 D_Write(0xCC);      //-- Issue Read Temp High Command
 D_Write(0xBE);      //-- Issue Read Temp Low Command
 TempL=D_Read();     //-- Read the "Low Temp"
 TempH=D_Read();     //-- Read the "High Temp"
 TempS=D_Read();     //-- read the status Byte

          //  termo0 = D_Read(); 
		//	termo1 = D_Read(); 
		//	th = D_Read(); 
		//	tl = D_Read(); 
		//	reserv1 = D_Read(); 
		//	reserv0 = D_Read(); 
		//	count_remain = D_Read(); 
		//	count_perc = D_Read(); 
		//	crc = D_Read(); 
}
//*********** END OF ReadCurrent

//************************************************************************
//                          WriteCurrent
//
//      thermo 
//************************************************************************
void WriteCurrent(void)
{
 D_Reset();          //-- Reset the Bus
 D_Write(0xCC);      //-- Issue Read Temp High Command
 D_Write(0x44);      //-- Issue Read Temp Low Command
}
//*********************************

//*****************************************
void
main(void)
{
	lcd_init();


	while(1)
	{


//  
 WriteCurrent();

DelayMs(100);
 ReadCurrent();               // -    


	secs=TempL/2;
    mins=TempH;


           

	//	temperature = ((float)(termo0))/2-0.25+((float)(count_perc - count_remain))/((float)(count_perc));
//	temperature = ((float)(3.25));//(3.25);//termo0);///2-0.25);//+((count_perc - count_remain))/((count_perc));
	//		sprintf (buf, "t=%4.1f", temperature);		//   

	sprintf( number,"%02u",secs);
 	sprintf(sec,"%02u",mins);
 


    //	lcd_line1();			//and print to LCD
	///	lcd_string(number);
	//	lcd_line2();
	//	lcd_string(sec);
 

	lcd_goto(0);	// select first line
	lcd_puts(sec);
	lcd_goto(0x40);	// Select second line
	lcd_puts(number);

	}
}
